# Custom Headers

Custom HTTP headers are useful when you want to provide additional information to your request. If your request requires passing custom HTTP headers, all you have to do is to append `WSA-` to your header's name and add them to your request.

For example, the `Sec-Fetch-Dest: document` header will be passed as `WSA-Sec-Fetch-Dest: document`.

{% hint style="warning" %}
Only use this feature to get customized results, do not use this feature to avoid blocks. BrowserAPI has a powerful internal engine that takes care of everything for you.
{% endhint %}

{% hint style="info" %}
Only the following headers can be overwritten:
{% endhint %}

* accept
* accept-encoding
* accept-language
* cache-control
* connection
* content-type
* dnt
* origin
* referer
* save-data
* sec-ch-ua
* sec-ch-ua-mobile
* sec-ch-ua-platform
* sec-fetch-dest
* sec-fetch-mode
* sec-fetch-site
* sec-fetch-user
* sentry-trace
* upgrade-insecure-requests
* user-agent x-amzn-trace-id
* x-forwarded-port
* x-i18n-language
* x-lpm-session
* x-requested-with
* x-unique-id

Additional headers may be added per domain by contacting our support.

### Custom Headers Integration Examples

{% tabs %}
{% tab title="cURL" %}
{% code overflow="wrap" fullWidth="true" %}

```bash
curl --request GET --url "https://api.webscrapingapi.com/v1?api_key=<YOUR_API_KEY>&url=http%3A%2F%2Fhttpbin.org%2Fheaders" --header "wsa-x-unique-id: unique"
```

{% endcode %}
{% endtab %}

{% tab title="NodeJS" %}
{% code overflow="wrap" %}

```javascript
const http = require("https");

const options = {
  "method": "GET",
  "hostname": "api.webscrapingapi.com",
  "port": null,
  "path": "/v1?api_key=<YOUR_API_KEY>&url=http%3A%2F%2Fhttpbin.org%2Fheaders",
  "headers": {
    "wsa-x-unique-id": "unique",
  }
};

const req = http.request(options, function (res) {
  const chunks = [];

  res.on("data", function (chunk) {
    chunks.push(chunk);
  });

  res.on("end", function () {
    const body = Buffer.concat(chunks);
    console.log(body.toString());
  });
});

req.end();
```

{% endcode %}
{% endtab %}

{% tab title="Python" %}
{% code overflow="wrap" %}

```python
import requests

API_KEY = '<YOUR_API_KEY>'
SCRAPER_URL = 'https://api.webscrapingapi.com/v1'

TARGET_URL = 'https://httpbin.org/headers'

HEADERS = {
    'wsa-x-unique-id': "unique",
}

PARAMS = {
    "api_key":API_KEY,
    "url": TARGET_URL,
    "render_js":1
}

response = requests.get(SCRAPER_URL, params=PARAMS, headers=HEADERS)

print(response.text)
```

{% endcode %}
{% endtab %}

{% tab title="PHP" %}
{% code overflow="wrap" %}

```php


```

{% endcode %}
{% endtab %}
{% endtabs %}

{% hint style="danger" %} <mark style="color:red;">**Important!**</mark> The `url` parameter has to be encoded.

*( i.e. **\&url=https%3A%2F%2Fwww\.webscrapingapi.com%2F** )*
{% endhint %}

<details>

<summary>Response Example</summary>

```html
<html><head><meta name="color-scheme" content="light dark"><meta charset="utf-8"></head><body><pre>{
  "headers": {
    "Accept": "text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.7", 
    "Accept-Encoding": "gzip, deflate, br, zstd", 
    "Accept-Language": "en-US,en;q=0.9", 
    "Host": "httpbin.org", 
    "Priority": "u=0, i", 
    "Sec-Ch-Ua": "\"Chromium\";v=\"116\", \"Not)A;Brand\";v=\"24\", \"Google Chrome\";v=\"116\"", 
    "Sec-Ch-Ua-Mobile": "?1", 
    "Sec-Ch-Ua-Platform": "\"Windows\"", 
    "Sec-Fetch-Dest": "document", 
    "Sec-Fetch-Mode": "navigate", 
    "Sec-Fetch-Site": "none", 
    "Sec-Fetch-User": "?1", 
    "Upgrade-Insecure-Requests": "1", 
    "User-Agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/116.0.0.0 Safari/537.36", 
    "X-Amzn-Trace-Id": "Root=1-6720a91f-6e5946dc225348484fc64090", 
    "X-Unique-Id": "unique"
  }
}
</pre><div class="json-formatter-container"></div></body></html>
```

</details>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.webscrapingapi.com/browser-api/advanced-api-features/custom-headers.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
